Subject: [Mip4] Request to advance draft-ietf-mip4-fmipv4-06.txt to Experimental RFC

From: "McCann Peter-A001034" <[email-masked]>
Date: Tue, 8 May 2007 13:26:48 -0400

This is a request to advance draft-ietf-mip4-fmipv4-06.txt,
"Mobile IPv4 Fast Handovers", to Experimental RFC.  The draft
has completed last call and all outstanding issues have been
addressed.

>    (1.a)  Who is the Document Shepherd for this document?  Has the
>           Document Shepherd personally reviewed this version of the
>           document and, in particular, does he or she believe this
>           version is ready for forwarding to the IESG for publication?

Pete McCann is the document shepherd.  Yes, I have personally 
reviewed the document and it is ready for publication.

>    (1.b)  Has the document had adequate review both from key WG
members
>           and from key non-WG members?  Does the Document Shepherd
have
>           any concerns about the depth or breadth of the reviews that
>           have been performed?

The document went through last call back in September of 2005 and
has been discussed actively.  We feel the document has obtained
sufficient review, and I have no concerns about the depth or breadth
of the reviews.

>    (1.c)  Does the Document Shepherd have concerns that the document
>           needs more review from a particular or broader perspective,
>           e.g., security, operational complexity, someone familiar
with
>           AAA, internationalization or XML?

No.

>    (1.d)  Does the Document Shepherd have any specific concerns or
>           issues with this document that the Responsible Area Director
>           and/or the IESG should be aware of?  For example, perhaps he
>           or she is uncomfortable with certain parts of the document,
or
>           has concerns whether there really is a need for it.  In any
>           event, if the WG has discussed those issues and has
indicated
>           that it still wishes to advance the document, detail those
>           concerns here.

No concerns.  All issues have been addressed.

>    (1.e)  How solid is the WG consensus behind this document?  Does it
>           represent the strong concurrence of a few individuals, with
>           others being silent, or does the WG as a whole understand
and
>           agree with it?

There is solid WG consensus behind the document.

>    (1.f)  Has anyone threatened an appeal or otherwise indicated
extreme
>           discontent?  If so, please summarise the areas of conflict
in
>           separate email messages to the Responsible Area Director.
(It
>           should be in a separate email because this questionnaire is
>           entered into the ID Tracker.)

No appeals have been threatened.

>    (1.g)  Has the Document Shepherd personally verified that the
>           document satisfies all ID nits?  (See
>           http://www.ietf.org/ID-Checklist.html and
>           http://tools.ietf.org/tools/idnits/).  Boilerplate checks
are
>           not enough; this check needs to be thorough.  Has the
document
>           met all formal review criteria it needs to, such as the MIB
>           Doctor, media type and URI type reviews?

The document has been checked for nits.  No nits found by the automated
checker and no nits found by proofreading.  The draft does not have any
serious dependencies on other working groups so the review done by MIP4
probably suffices.

>    (1.h)  Has the document split its references into normative and
>           informative?  Are there normative references to documents
that
>           are not ready for advancement or are otherwise in an unclear
>           state?  If such normative references exist, what is the
>           strategy for their completion?  Are there normative
references
>           that are downward references, as described in [RFC3967]?  If
>           so, list these downward references to support the Area
>           Director in the Last Call procedure for them [RFC3967].

Yes, references are split.  All normative references are published RFCs.
As this draft is intended for Experimental status, there are no downward
references.

>    (1.i)  Has the Document Shepherd verified that the document IANA
>           consideration section exists and is consistent with the body
>           of the document?  If the document specifies protocol
>           extensions, are reservations requested in appropriate IANA
>           registries?  Are the IANA registries clearly identified?  If
>           the document creates a new registry, does it define the
>           proposed initial contents of the registry and an allocation
>           procedure for future registrations?  Does it suggested a
>           reasonable name for the new registry?  See
>           [I-D.narten-iana-considerations-rfc2434bis].  If the
document
>           describes an Expert Review process has Shepherd conferred
with
>           the Responsible Area Director so that the IESG can appoint
the
>           needed Expert during the IESG Evaluation?

The document contains a detailed IANA section.  The document does not
create any new registries.  The requested allocations are described with
appropriate references to the number spaces.

>    (1.j)  Has the Document Shepherd verified that sections of the
>           document that are written in a formal language, such as XML
>           code, BNF rules, MIB definitions, etc., validate correctly
in
>           an automated checker?

There are no formal language descriptions in the document.

>    (1.k)  The IESG approval announcement includes a Document
>           Announcement Write-Up.  Please provide such a Document
>           Announcement Writeup?  Recent examples can be found in the
>           "Action" announcements for approved documents.  The approval
>           announcement contains the following sections:
> 
>           Technical Summary

The document describes a new protocol designed to reduce the
latency and packet loss experienced during handover.  It does
so by introducing new messages to be used among the Mobile Node (MN),
Previous Access Router (PAR) and New Access Router (NAR).  The
messages allow the MN to establish a binding at the PAR such that
packets are forwarded to/from the NAR immediately after a handover.
This avoids the long round-trip time to the home network that would
be incurred by a standard Mobile IPv4 messsage flow.

>           Working Group Summary

The document underwent working group last call in September 2005,
and has been actively discussed and edited since then.

>           Personnel
>              Who is the Document Shepherd for this document?  Who is
the
>              Responsible Area Director?

Pete McCann is the document shepherd.  Jari Arkko is the responsible AD.

-Pete

-- 
Mip4 mailing list: [email-masked]
    Web interface: https://www1.ietf.org/mailman/listinfo/mip4
     Charter page: http://www.ietf.org/html.charters/mip4-charter.html
Supplemental site: http://www.mip4.org/

---

From: Jari Arkko <[email-masked]>
Date: Fri, 11 May 2007 15:22:20 +0300

Pete, all,

I have reviewed this specification and while it is generally
in good shape for an Experimental RFC publication, there
were a number of questions and issues that I believe need
to be addressed before we can go to IETF Last Call.

In Section 3, did you mean "default router reachability"
when you wrote "default agent reachability"?

Section 6.3 says this:

> New Access Point Link-layer Address: The link-layer address or
> identification of the access point for which the MN requests
> routing advertisement information. It MUST be included in all
> RtSolPr messages. More than one such address or identifier can
> be present. This field can also be a wildcard address (see
> Section 7.1).

And then later Section 6.4

> New Access Point Link-layer Address: The link-layer address or
> identification of the access point is copied from RtSolPr
> message. This option MUST be present.
>
> ...
>
> New CoA Option: MAY be present when PrRtAdv is sent
> unsolicited.

There are a couple of issues around the role of New Access Point
Link-layer Address option. Since you allow wildcards, what does
the copying requirement mean? Copy the wildcard, or the matching
entries?

> New CoA Option: MAY be present when PrRtAdv is sent
> unsolicited. PAR MAY compute new CoA using NAR's prefix
> information and the MN's L2 address, or by any other means. In
> any case, the MN should be prepared to use this address instead
> of performing DHCP or similar operations to obtain an IPv4
> address.
First, why would this be present only in an unsolicited message?

Second, the combination of prefix and L2 address appears to be
copied from IPv6 and not directly applicable in IPv4.

Third, how is the lifetime of this address determined? When can the
new access router re-allocate the same address for someone else?
Why is there no instruction on what the NAR/PAR does in order to
find such addresses. RFC 4068 had these instructions... Or are you
saying in Section 1 that you always use foreign agent care-of
address? If so, please require this later in the document when
you transport the addresses around.

In Section 6.4 you say:

> New Access Point Link-layer Address: The link-layer address or
> identification of the access point is copied from RtSolPr
> message. This option MUST be present.
>
> ...
>
> A Proxy Router Advertisement with Code 3 means that new router
> information is only present for a subset of access points requested.
> The Option-Code values in the LLA option distinguish different
> outcomes (see Section 7.1).

If we get Code 3, is there a New Access Point Link-layer Address
option included anyway? What would its contents be, in this case?

> Type: To be assigned by IANA
>
> Code: 0
RtSolPr and PrRtAdv ask for an ICMP Type code
to be assigned. I'm trying to understand why,
given that RFC 4068 uses type code 150 allocated
in RFC 4065 for experimental mobility purposes.
RFC 4065 has a corresponding type code for IPv4,
too (value 41).

> 9. IANA Considerations
>
> All the messages and the option formats specified in this document
> require Type assignment from IANA. Specifically, the Types, Sub-
> types and the Codes need assignment from ICMP, Mobile IP and
> Experimental Mobility Type [rfc4065] registries.

It took a while for me to parse what this means, and it would be
better if you can write the IANA instructions in a more explicit
manner. In particular, you are asking ICMP Types and Mobile IP
Type allocations, so at least explain what values are allocating
from what registry. Also, this section may be affected by
any changes resulting from my previous comment.

Finally, the IANA considerations section is missing all instructions
regarding future allocations from Option-Code and Code fields.
Are these namespaces expected to be independent new spaces,
or go in sync with RFC 4068?

Jari

---

From: Rajeev Koodli <[email-masked]>
Date: Fri, 11 May 2007 14:22:13 -0700

Hi Jari,

Thanks for the review. See my responses inline.

> when you wrote "default agent reachability"?

Yes (we have assumed FA acting as a router).
> the copying requirement mean? Copy the wildcard, or the matching

It's the LLA. Wildcard only says provide information about all possible
neighborhood access points.

PrRtAdv contains the [AP-ID, AR-Info] tuple, which is what you see as Valid
options in Section 6.4. Multiple such tuples may be present as a result of
multiples LLAs present or a wildcard request in RtSolPr.

So, the copy statement is applicable to LLAs present in RtSolPr. When the
wildcard is present, PAR includes the LLA on its own. If it would help, I
can add a sentence to make it clear.

> First, why would this be present only in an unsolicited message?

In RFC 4068, the unsolicited mode means a network-initiated handover, in
which case the MN needs an NCoA, which is supplied in PrRtAdv. We have
re-used it here, even though we do not bind the PCoA to NCoA (but to the new
FA's address). 
 
> copied from IPv6 and not directly applicable in IPv4.

Yes.

> you transport the addresses around.

Even with New CoA, the binding is always for the new FA's address. I will
add this requirement again in Section 6.4.

> option included anyway? What would its contents be, in this case?

Yes. It is only saying that the [AP-ID, AR-Info] tuples are present for only
a subset of all the APs included in the RtSolPr.

> RFC 4065 has a corresponding type code for IPv4,

You are right. I forgot to update it after writing the IANA section.

> any changes resulting from my previous comment.

The subsequent paragraphs describe what assignments are needed, no?

> or go in sync with RFC 4068?

I assumed they would just be in sync with RFC 4068. I can add some text as
such.

-Rajeev

---

From: Jari Arkko <[email-masked]>
Date: Mon, 14 May 2007 15:17:04 +0300

Rajeev,

> can add a sentence to make it clear.

Please change the text -- if you actually provide the link
layer addresses for all access points, then you are not
copying the LLA option from request to advertisement;
you are replacing the wildcard LLA with a number of
specific LLAs, right?

> re-used it here, even though we do not bind the PCoA to NCoA (but to the new

Ok, but are you saying that if the mobile node initiates
the handover, then the PAR can not provide an NCoA?
That is, what is the keyword  that you would use for
solicited messages? MAY as well? Or maybe MUST NOT,
if you disallow this?

> add this requirement again in Section 6.4.

Good.

> a subset of all the APs included in the RtSolPr.

That's fine, but then it also means that the MUST that appeared
earlier about the copying of LLAs from request to advertisement
cannot be fulfilled. You need to adjust the MUST statement
to say what you actually need to be done. Currently it makes
an overall statement that does not appear to be the desired
behaviour in a number of special cases (wildcard, code 3).

> You are right. I forgot to update it after writing the IANA section.

Ok, please update this.

> The subsequent paragraphs describe what assignments are needed, no?

Ah, yes. I must have been looking at the old revision.

> I assumed they would just be in sync with RFC 4068. I can add some text as
Great!

Jari

---

From: Rajeev Koodli <[email-masked]>
Date: Mon, 14 May 2007 12:56:58 -0700

Yes.

> solicited messages? MAY as well? Or maybe MUST NOT,

The specification does not disallow it (i.e., no MUST NOT), nor does it
specify it. Traditionally, the NCoA option has only been used with
unsolicited PrRtAdv (as a network-initiated handover).

In principle, there is no reason not to use the option in solicited PrRtAdv
as well. However, unlike the unsolicited scenario, the solicited PrRtAdv
message is not tightly synchronized with the actual handover itself (i.e.,
neighborhood discovery [proxy router messages] and fast route update
[fbu/fback] are logically independent phases). Also, providing NCoA when
multiple LLAs are present in RtSolPr introduces ambiguity since the MN
cannot determine on which AP it could use the supplied NCoA.

So, perhaps we should state that use of NCoA in solicited PrRtAdv is
unspecified in this version of the document, and some text reflecting the
above description?

> behaviour in a number of special cases (wildcard, code 3).

Ok.

-Rajeev

---

From: Rajeev Koodli <[email-masked]>
Date: Mon, 14 May 2007 15:51:53 -0700

> 
> In principle, there is no reason not to use the option in solicited PrRtAdv as
> well. However, unlike the unsolicited scenario, the solicited PrRtAdv message
> is not tightly synchronized with the actual handover itself (i.e.,
> multiple LLAs are present in RtSolPr introduces ambiguity since the MN cannot
> determine on which AP it could use the supplied NCoA.

Actually, this last point _can_ be clarified because the new CoA option is
part of an ordered tuple (section 6.4). Hence, if there are multiple LLAs
present, each may have its own (or the same) new CoA option or none at all..

-Rajeev

---

From: Jari Arkko <[email-masked]>
Date: Tue, 15 May 2007 08:08:44 +0300

Rajeev,

> unspecified in this version of the document, and some text reflecting the

That would work for me.

Jari